
; by Fabio Ciucci - Assemblieren mit "A", ausfhren mit "J"

Waitmouse:		      ; diese LABEL steht als Referenzpunkt fr das bne
	move.w	$dff006,$dff180	; gib den Wert von $dff006 in $dff180
				; also von VHPOSR in COLOR00
	btst	#6,$bfe001	; linke Maustaste gedrckt?
	bne.s	Waitmouse	; wenn nicht, kehre zu Waitmouse zurck
				; und wiederhole
	rts			; Ende, steig aus

	END

; Anmerkung: der Befehl MOVE bedeutet soviel wie "Bewege", besser noch kopiere
; den Wert, der im ersten Operand enthalten ist, in den zweiten, in diesem Fall
; "LESE DEN WERT IN $DFF006 UND GIB IHN IN $DFF180". Das .w bedeutet, da
; ein Word bewegt wird, also 2 Bytes -> 16 Bit (1 Byte = 8 Bit, 1 Word = 16
; Bit, 1 Longword = 32 Bit).
; Anmerkung 2: das BTST, gefolgt vom BNE dient dazu, einen Sprung im Programm
; zu machen, wenn eine Kondition eintrifft; es lt sich so bersetzen:
; BTST = KONTROLLIERE, OB FRITZ DEN APFEL GEGESSEN HAT, UND SCHREIBE ES AUF
; EIN STCK PAPIER.
; BNE = DAS BNE LIET AUF DEM STCK PAPIER, OB FRITZ DEN APFEL GEGESSEN HAT,
; ER WEI, DA ER DAS NICHT SELBST TUN KANN, DAFR HAT ES IHM SEIN FREUND
; BTST GETAN... IM FALLE, DA AUF DEM PAPIERFETZEN STEHT, DA FRITZ DEN APFEL
; NICHT GEGESSEN HAT, DANN SPRINGE ZUR ANGEGEBENEN LABEL
; (BEI UNS BNE.S Waitmouse).
; Praktisch, wenn Fritz den Apfel nicht gegessen hat, springt der Prozessor
; zum Waitmaouse zurck und wiederhole alles; wenn er ihn hingegen gegessen
; hat, dann springe nicht zu Waitmouse, sondern fahre unter dem Befehl BNE
; fort. Hier findet er beim Beispielprogramm ein RTS, und damit ist das
; Programm zu Ende.
; Das Stck Papier, auf dem das BTST das Urteil fr das BNE schreibt, heit
; STATUS REGISTER, oder SR. Wenn statt dem BNE ein BEQ stehen wrde, dann
; wrde die Schleife nur solange ausgefhrt, solange der Mausknopf gedrckt
; ist, und wrde enden, sobald er losgelassen wrde. (Das Gegenteil: Denn
; BNE bedeutet BRANCH IF NOT EQUAL, also SPRINGE, WENN NICHT GLEICH (falsch),
; whrend BEQ fr BRANCH IF EQUAL steht, SPRINGE WENN GLEICH (wahr)).
; In der ersten Zeile wird der Wert ausgelesen, der sich in $dff006 befindet,
; also die Position des Elektronenstrahls auf dem Monitor, die sich klarerweise
; dauernd ndert ( so um die 50 mal pro Sekunde). Dieser Wert wird dann
; in die Adresse $DFF180 geschrieben, die die Farbe 0 kontrolliert, als
; Folge davon erhlt man also den Bildschirm, der flackert, da die Farbe stets 
; gendert wird.
; Verifiziert, da $DFF006 VHPOSR ist, indem ihr "=C 006" eintippt, das
; gleiche gilt fr $DFF180 mit "=C 180". Diese Hilfe knnt ihr dem ASMONE
; ber jedes Register aus der Reihe $DFFxxx abverlangen.
; Das Format der Farben ist das folgende: $0RGB, das Word (2 Byte) des 
; Registers ist also in RED, GREEN, BLUE aufgeteilt, mit 16 Tonalitten
; (Farbabstufungen) pro Farbe; durch Mischen wie mit der PALETTE des
; Deluxe Paint kann man so eine der 4096 mglichen Farben auswhlen
; (16x16x16=4096). Jeder Wert von Red, Green und Blue, also Rot, Grn
; und Blau, geht von 0 bis F (Hexzahlen...!). Probiert z.B. die erste 
; Zeile durch MOVE.W #$000,$DFF180 zu ersetzen: ihr werdet den Bildschirm
; in elegantes Schwarz hllen, oder mit MOVE.W #$000e,$DFF180 , das
; ergibt ein modisches Blau, und mit MOVE.W #$cd0,$dff180 ein freches
; Gelb (Rot + Grn). Probiert selbst, die Farben zu tauschen, um zu
; kontrollieren, ob ihr den Mechanismus verstanden habt.
; #$444 = Grau, #$900 = Dunkelrot, #$e00 = helles Rot, #$0a0 Grn...
; Wenn ihr nun $dff180 durch $dff182 ersetzt, blinken nun die Schriften
; an Stelle des Hintergrundes, also das, was mit Farbe 1 (Color1) 
; "gemalt" ist.
; Der Befehl BTST kontrolliert, ob ein bestimmtes Bit an einer Adresse 0 ist
; Erinnert euch, da die Bits von rechts nach links gelesen werden und
; da man bei 0 startet, z.B. in einem Byte, das so aussieht:
; %01000000  Hier ist das sechste Bit auf 1:
;
; 76543210			5432109876543210
; 01000000 	ein Word:	0001000000000000 <= Hier ist Bit 12 auf 1!
;
; P.S: Das erste Bit wird Bit 0 und nicht Bit 1 genannt, da darf man sich
;      nicht verfehlen, also da das siebte Bit "Bit 6" genannt wird. Um
;      nichts falsch zu machen, gebt ev. eine Numerierung ber die
;      Binrzahl.
; 
; Das Bit 6 von $bfe001 ist der linke Mausknopf. Der Name des Registers
; ist CIAAPRA, aber das erinnert sich sowieso niemand...
; Der rechte Mausknopf hingegen befindet sich auf Bit 2 von $dff016. Testet
; mal, was passiert, wenn ihr BTST #6,$bfe001 mit BTST #2,$bfe016 ersetzt.
; Was wohl...jetzt brauchts den rechten Mausknopf, um alles abzubrechen!
; Macht mir ja alle vorgeschlagenen nderungen, dann bt ihr!!
; Anmerkung: Wenn ihr die Programme so speichern wollt, da sie von
; der Shell/CLI ausfhrbar sind, mt ihr nur ein "WO" tippen, nachdem
; ihr mit "A" assembliert habt. Gebt im Fenster einen Namen ein, und
; speichert es auf eine andere Diskette ab! Wehe, ihr berschreibt
; meinen Kurs!!! Schreibschutz zu!
; Wollt ihr aber das Listing abspeichern, tippt "W" (immer auf eine andere
; Diskette !!!)

; PSPS: Habt ihr beim BNE den Suffix bemerkt? Er war weder .B, noch .W
; und auch nicht .L! Bei Befehlen wie BNE, BEQ, BSR kann man nur zwischen
; .B und .W auswhlen, am Resultat ndert sich aber nichts, denn BNE.B
; tut genau das gleiche wie BNE.W. Bei diesen Befehlen ist erlaubt, ein
; .s anstelle des .B zu verwenden, es steht fr SHORT (kurz), und man
; kann es nur verwenden, wenn das Label, das angesprungen werden soll,
; nicht zu "weit weg" liegt. Ansonsten ersetzt der ASMONE whrend des 
; assemblierens automatisch das .s in .W. Da das .S (das wie gesagt fr
; .B steht, nur fr solche Instruktionen in Frage kommt, glaube ich, ist
; es besser, man verwendet es. Nun wit ihrs, es drften keine Probleme
; mehr auftreten.
; PSPSPS: Wenn ihr trotzdem ein .L unterschmuggelt, sieht es der ASMONE
; als .W, und assembliert es dementsprechend, andere Assembler melden
; einen Fehler. Wenn ihr vergesst, einen Suffix zu geben (BNE LABEL), 
; wird es immer als .W interpretiert. Das gleiche gilt fr die anderen
; Befehle. Ein MOVE $10,$20 ergibt keinen Fehler, denn es wird als
; MOVE.W $10,$20 angeschaut. DAS BEDEUTET ABER NICHT, DA ALLE ASSEMBLER
; GLEICH GTIG SIND!! Daher hngt ihn immer an, es ist auch sthetisch
; schner... 

