
; Listing2i.s

Anfang:
	lea	$dff000,a0	; Gib $dff000 in a0
Waitmouse:
	move.w	6(a0),$180(a0)	; Gib den .W-Wert von $dff006 in COLOR0
				; 6(a0)=$dff000+6, $180(a0)=$dff000+$180
	btst	#6,$bfe001	; linke Maustaste gedrckt?
	bne.s	Waitmouse	; wenn nicht, zurck zu Waitmouse
	rts			; Ende

	END

In   dieser  Variante  des  ersten  Listings  sind  Adressierungsdistanzen
eingefgt: in a0 kommt die Adresse $dff000, und dann werden die  Distanzen
angegeben.  Ich  habe  $dff000 gewhlt, weil es eine "gerade" Adresse ist,
denn um $dff180 (COLOR0) zu erreichen, brauche ich eine Distanz  von  $180
($180(a0)), und so ist sofort eindeutig, was fr eine Adresse gemeint ist.
Htte ich hingegen $dff013 in a0 geschrieben htte, dann wre $16d(a0) die
richtige  Distanz  gewesen  ($dff013 + $16d = $dff180). Wre aber nicht so
klar. Zu Beachten ist, da das Register a0 nie verndert wird, es  bleibt,
wie es ist, $dff000, bei jedem Aufruf zhlt der Prozessor die Distanz dazu
und errechnet somit die neue Adresse. In fast allen  Programmen,  die  mit
Grafik  arbeiten,  wird die Adresse $dff000 in irgend ein Register gegeben
und dann  werden  die  Adressierungen  auf  die  gerade  beschriebene  Art
durchgefhrt,  auch  OFFSET  genannt.  Somit kann man alle CUSTOM-REGISTER
erreichen, sie gehen von $dff000 bis $dff1fe.  Man  kann  einen  maximalen
Offset von -32768 bis +32767 erreichen, also von -$8000 bis $7FFF.

Bemerkung:  Achtet  auf den Unterschied, der zwischen dem LEA und dem MOVE
besteht, wenn eine Adressierungsdistanz verwendet wird:

	MOVE.L	$100(a0),a1

Kopiert das Longword, das an Adresse a0 plus $100 Bytes ENTHALTEN ist, ins
Register a1. Also: MACHE DIE SUMME VON ADRESSE IN A0 UND OFFSET (DIE ZAHL
VOR DER KLAMMER); DAS RESULTAT DAVON IST DIE ADRESSE, DEREN INHALT IN A1
KOPIERT WIRD.

Whrend:

	LEA	$100(a0),a1

Gibt in a1 die Adresse a0+$100 selbst, nicht deren Inhalt, denn LEA kann
ausschlielich ADRESSEN laden, KEINE INHALTE.

Machen  wir  ein Beispiel, das alles noch ein bichen klarer macht: Stellt
euch den Speicher wie  eine  lange,  einsame  Strae  mit  vielen  kleinen
Huschen vor, alle in Reih und Glied, und jedes mit einer Hausnummer. Wenn
wir in a0 die Adresse 0 geben, also die Adresse des  ersten  Hauses,  dann
wird  der  Befehl  MOVE.L  $100(a0),a1  nichts anderes tun, als zu Adresse
a0+$100 = $100 zu gehen, und Teppich, Mbel, Betten usw. in a1  zu  geben.
Es  wurde  also  der  INHALT  des Hauses in $100(a0) kopiert, im Falle des
MOVE.L ein Longword ab der angegebenen Adresse. Mit  dem  LEA  $100(a0),a1
hingegen  wandert  nur die Adresse des Hauses in a1, also $100 + a0 = $100
(im Beispiel),  wir  treten  ins  Haus  nicht  ein.  Der  Unterschied  ist
letztendlich  eben  der, da wir mit einem MOVE in a1 die Mbel des Hauses
kopiert haben, mit dem LEA nur die Adresse. Fr INHALT meine ich das,  was
in der Adresse enthalten ist, denn in jeder Adresse (jedem Haus) ist etwas
enthalten: es knnen Zahlen sein (die Mbel) oder es kann leer sein  (wenn
das Haus verlassen ist), dafr knnen wir aber immer NULL ($00) nehmen.

Z.B. ist der Befehl:

	LEA	$100(a1),a1

identisch mit dem Befehl:

	ADD.W	#$100,a1

In a1 wird eben die Adresse a1+$100 gegeben.

Bemerkung:  Die  Adressierungsdistanzen (Offset) knnt ihr in Dezimal oder
in Hexadezimal (mit dem $-Symbol) schreiben, ganz wies euch gefllt,  ihr
knnt auch Multiplikationen, Divisionen usw. einflieen lassen:

	LEA	$10+3(a1),a2	; es wird als LEA $30(a1),a2 assembliert
				; werden, denn das * steht fr 
				; MULTIPLIZIERE


